<?php
/**
* @version 2.3.4
* @package PWebContact
* @copyright © 2012 Majestic Media sp. z o.o., All rights reserved. http://www.perfect-web.co
* @license GNU General Public Licence http://www.gnu.org/licenses/gpl-3.0.html
* @author Piotr Moćko
*/

//PHP 4 compatibility
if (!function_exists('json_encode'))
{
	function json_encode($a=false){if(is_null($a))return 'null';if($a===false)return 'false';if($a===true)return 'true';if(is_scalar($a)){if(is_float($a)){return floatval(str_replace(",",".",strval($a)));}if(is_string($a)){static $jsonReplaces=array(array("\\","/","\n","\t","\r","\b","\f",'"'),array('\\\\','\\/','\\n','\\t','\\r','\\b','\\f','\"'));return '"'.str_replace($jsonReplaces[0],$jsonReplaces[1],$a).'"';}else return $a;}$isList=true;for($i=0,reset($a);$i<count($a);$i++,next($a)){if(key($a)!==$i){$isList=false;break;}}$result=array();if($isList){foreach($a as $v)$result[]=json_encode($v);return '['.join(',',$result).']';}else{foreach($a as $k=>$v)$result[]=json_encode($k).':'.json_encode($v);return '{'.join(',',$result).'}';}}
}

// Joomla main index.php file
define('_JEXEC', 1);

define('DS', DIRECTORY_SEPARATOR);
define('JPATH_BASE', str_replace( DS.'modules'.DS.'mod_pwebcontact', '', dirname(__FILE__) )); //j1.5

require_once (JPATH_BASE .'/includes/defines.php');
require_once (JPATH_BASE .'/includes/framework.php');

$app =& JFactory::getApplication('site');
$app->initialise();
// end

global $mainframe; //j1.5
$mainframe =& $app; //j1.5

JResponse::allowCache(false);
JResponse::setHeader('Content-Type', 'text/plain');
JResponse::toString();

if (($module_id = JRequest::getInt('mid', 0)) > 0) 
{
	require_once (JPATH_BASE.'/modules/mod_pwebcontact/helpers15/helper.php'); //j1.5
	
	$params = modPWebContactHelper::getParams($module_id);
	
	//Debug
	if ($app->getCfg('debug') OR JRequest::getInt('debug')) $params->set('debug', 1);
	
	define('PWEBCONTACT_DEBUG', $params->get('debug'));
	
	//Logs
	if (PWEBCONTACT_DEBUG) 
	{
		jimport('joomla.error.log'); // j1.5
		
		$log =& JLog::getInstance('mod_pwebcontact.log.php'); // j1.5
		$log->addEntry( array('comment'=>'Ajax response initialized', 'status'=>'debug') ); // j1.5
	}
	
	//Language
	$lang =& JFactory::getLanguage();
	if ($params->get('rtl', 2) == 2) {
		if ($lang->isRTL())
			$params->set('rtl', 1);
		else
			$params->set('rtl', 0);
	}
	$lang->load('mod_pwebcontact');
	
	if (PWEBCONTACT_DEBUG) $log->addEntry( array('comment'=>'Language file loaded', 'status'=>'debug') ); // j1.5
	
	// Set media path
	$params->set('media_url', 	str_replace('modules/mod_pwebcontact/', '', JURI::base()).'media/mod_pwebcontact/');
	$params->set('media_path', 	JPATH_ROOT.'/media/mod_pwebcontact/');
	$params->set('upload_path', JPATH_ROOT.'/media/mod_pwebcontact/upload/'.$module_id.'/');
	$params->set('module_path', JPATH_ROOT.'/modules/mod_pwebcontact/'); // j1.5

	if (JRequest::getVar('qqfile', '', 'get')) 
	{
		//Upload files
		$response =  modPWebContactUploader::upload();
	} 
	else 
	{
		//Submit message
		$response = modPWebContactHelper::submit();
		
		// delete atachments if respnse status is 1=success, 3,4=error
		// and set in configuration to delete after sending
		if (isset($response['status']) AND in_array($response['status'], array(1, 3, 4)) AND $params->get('attachment_delete') AND $params->get('attachment_type', 1))
		{
			if (PWEBCONTACT_DEBUG) $log->addEntry( array('comment'=>'Delete atachments', 'status'=>'debug') ); // j1.5
			modPWebContactUploader::deleteAtachments();
		}
	}
	
	// Catch all system messages
	if (isset($response['debug'])) 
		$response['debug'] .= "\r\n";
	else 
		$response['debug'] = '';
	$messages = $app->getMessageQueue();
	foreach ($messages as $message)
	{
		$response['debug'] .= $message['type'] .': '. $message['message'] ."\r\n";
	}
	
	echo json_encode($response);
	
	if (PWEBCONTACT_DEBUG) $log->addEntry( array('comment'=>'Ajax response exit', 'status'=>'debug') ); // j1.5
}
elseif (JRequest::getInt('getToken', 0, 'get')) 
{
	echo json_encode(array('token' => JUtility::getToken()));
}

jexit();