<?php
/**
* @version 2.3.6
* @package PWebContact
* @copyright © 2012 Majestic Media sp. z o.o., All rights reserved. http://www.perfect-web.co
* @license GNU General Public Licence http://www.gnu.org/licenses/gpl-3.0.html
* @author Piotr Moćko
*/
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.html.parameter.element.radio');
JLoader::register('JElementRadio', JPATH_LIBRARIES.DS.'joomla'.DS.'html'.DS.'parameter'.DS.'element'.DS.'radio.php');

/**
 * Perfect-Web
 *
 * @subpackage	mod_pwebcontact
 * @since		1.5
 */
class JElementPweb extends JElementRadio
{
	/**
	 * Element name
	 *
	 * @access	protected
	 * @var		string
	 */
	var	$_name = 'Pweb';
	var $extension = 'mod_pwebcontact';
	var $version = '2.3.5';
	var $documentation = 'http://www.perfect-web.co/joomla/ajax-contact-form-popup-module/documentation';

	function fetchElement($name, $value, &$node, $control_name = 'params')
	{
		$app =& JFactory::getApplication();
		$doc =& JFactory::getDocument();
		
		// check Joomla configuration
		jimport('joomla.mail.helper');
		if ( JMailHelper::isEmailAddress($app->getCfg('mailfrom')) == false ) 
		{
			JError::raiseWarning(500, 'Set Mail from field in <a href="index.php?option=com_config#mailer" onclick="Cookie.set(\'configuration\',\'server\')" target="_blank">Joomla! Global Configuration</a>');
		}
		
		// check if PHP mail functon is enabled
		if ($app->getCfg('mailer') == 'mail' && !(function_exists('mail') && is_callable('mail')))
		{
			$app->enqueueMessage('PHP mail function is disabled. Use SMTP mode in Mail section of <a href="index.php?option=com_config#mailer" onclick="Cookie.set(\'configuration\',\'server\')" target="_blank">Joomla! Global Configuration</a>', 'warning');
		}
		
		// check module configuration
		$module_id = JRequest::getVar('id', 0);
		if ($module_id == 0) 
		{
			$module_cid = JRequest::getVar('cid', array());
			if (count($module_cid)) $module_id = $module_cid[0];
		}
		if ($module_id > 0) 
		{
			// get params
			include_once JPATH_ROOT.'/modules/mod_pwebcontact/helpers15/helper.php';
			$params = modPWebContactHelper::getParams($module_id);
			
			// check if debug is on
			if ($params->get('debug', 0)) JError::raiseNotice(500, 'Disable debug mode when finished testing!');
			
			// check if upload directory is writable
			if ($params->get('show_upload', 0))
			{
				jimport('joomla.filesystem.folder');
				$path = '/media/mod_pwebcontact/upload/'.$module_id.'/';
				JFolder::create(JPATH_ROOT.$path);
				
				if (!is_writable(JPATH_ROOT.$path)) 
					JError::raiseWarning(500, 'Upload directory is not writable: '.$path);
				elseif (!JFile::exists(JPATH_ROOT.$path.'index.html'))
					JFile::copy(JPATH_ROOT.'/media/index.html', JPATH_ROOT.$path.'index.html');
			}
		}
		
		
		// check functions for image creation
		$functions = array(
			'imagecreatetruecolor',
			'imagecolorallocate',
			'imagecolorallocatealpha',
			'imagesavealpha',
			'imagealphablending',
			'imagefill',
			'imagettftext',
			'imagepng',
			'imagedestroy'
		);
		$disabled_functions = array();
		foreach ($functions as $function)
			if (!function_exists($function)) $disabled_functions[] = $function;
		
		if (count($disabled_functions)) $app->enqueueMessage('PHP functions for creation vertical toggler tab are disabled: '.implode(', ', $disabled_functions), 'warning');
		
		// check path for toggler image tab
		$path = '/modules/mod_pwebcontact/images/toggler/'; //j1.5
		if (!is_writable(JPATH_ROOT.$path)) $app->enqueueMessage('Directory for vertical toggler tab is not writable: '.$path, 'warning');
		
		
		// add documentation toolbar button
		$button = '<a href="'.$this->documentation.'" style="font-weight:bold;border-color:#025A8D;background-color:#DBE4E9;" target="_blank"><span class="icon-32-help"> </span> '.JText::_('MOD_PWEBCONTACT_DOCUMENTATION').'</a>';
		
		$bar =& JToolBar::getInstance();
		$bar->appendButton('Custom', $button, $this->extension.'-docs');
		
		// add feed script
		if ($value)
		{
			$doc->addScriptDeclaration(
				'(function(){'.
				'var pw=document.createElement("script");pw.type="text/javascript";pw.async=true;'.
				'pw.src="//www.perfect-web.co/updates/feed.js?ext='.$this->extension.'&v='.$this->version.'&j='.JVERSION.'";'.
				'var s=document.getElementsByTagName("script")[0];s.parentNode.insertBefore(pw,s);'.
				'})();'
			);
		}
		
		return parent::fetchElement($name, $value, $node, $control_name);
	}
}