<?php
/**
* @version 2.3.3
* @package PWebContact
* @subpackage SobiPro
* @copyright © 2012 Majestic Media sp. z o.o., All rights reserved. http://www.perfect-web.co
* @license GNU General Public Licence http://www.gnu.org/licenses/gpl-3.0.html
* @author Piotr Moćko
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

class modPWebContactSobiProHelper
{
	public static function isEntryView() 
	{
		if ( file_exists(JPATH_ROOT.'/components/com_sobipro/sobipro.php') && JRequest::getVar('option') == 'com_sobipro' && ($entry_id = JRequest::getInt('sid', 0)) ) {
			
			$db =& JFactory::getDBO();
		
			//get SobiPro object type
			$db->setQuery('SELECT oType FROM #__sobipro_object WHERE id = ' . $entry_id); //j1.5
			$type = $db->loadResult();
			
			if ($type == 'entry') return true;
		}
		
		return false;
	}
	
	
	public static function getHiddenField() 
	{
		$params = modPWebContactHelper::getParams();
		$html 	= '';
		
		if ( file_exists(JPATH_ROOT.'/components/com_sobipro/sobipro.php') && $params->get('sobipro') && ($entry_id = JRequest::getInt('sid', 0)) ) {
			
			if ($params->get('sobipro_entry')) {
				$html = '<input type="hidden" name="sobipro" value="'.$entry_id.'" />';
			}
			elseif (JRequest::getVar('option') == 'com_sobipro') {
			
				$db =& JFactory::getDBO();
			
				//get SobiPro object type
				$db->setQuery('SELECT oType FROM #__sobipro_object WHERE id = ' . $entry_id); //j1.5
				$type = $db->loadResult();
				
				if ($type == 'entry') 
					$html = '<input type="hidden" name="sobipro" value="'.$entry_id.'" />';
			}
		}
		return $html;
	}
	
	
	public static function getEmail($entry_id = 0) 
	{
		if (PWEBCONTACT_DEBUG) $log =& JLog::getInstance('mod_pwebcontact.log.php'); // j1.5
		
		$db  =& JFactory::getDBO();
		
		//get SobiPro entry email
		$db->setQuery(
			'SELECT d.baseData'.
			' FROM #__sobipro_field AS f'.
			' LEFT JOIN #__sobipro_field_data AS d ON d.fid = f.fid '.
			'WHERE d.sid = ' . $entry_id.
			' AND f.enabled = 1'.
			' AND (f.fieldType = "email" OR f.filter = "email")', 
			0, 1); //j1.5
		$email = $db->loadResult();

		if ($error = $db->getErrorMsg()) {
			if (PWEBCONTACT_DEBUG) $log->addEntry( array('comment'=>'SobiPro query error: '.$error, 'status'=>'error') ); //j1.5
			return false;
		}
		if (!empty($email)) {
			if (JMailHelper::isEmailAddress($email)) return $email;
			else {
				$result = modPWebContactSobiProHelper::unserialize($email);
				if ($result !== false && is_array($result)) {
					foreach ($result as $a)
						if (JMailHelper::isEmailAddress($a)) return $a;
				}
			}
		}
		
		//get SobiPro entry owner email
		$db->setQuery('SELECT u.email FROM #__sobipro_object AS o LEFT JOIN #__users AS u ON u.id = o.owner WHERE o.id = ' . $entry_id); //j1.5
		$email = $db->loadResult();
		
		if ($error = $db->getErrorMsg()) {
			if (PWEBCONTACT_DEBUG) $log->addEntry( array('comment'=>'SobiPro query error: '.$error, 'status'=>'error') ); //j1.5
			return false;
		}
		if (!empty($email)) {
			return $email;
		}
		
		return false;
	}
	
	
	private static function unserialize($var)
	{
		$r = null;
		if( is_string( $var ) && strlen( $var ) > 2 ) {
			if( ( $var2 = base64_decode( $var, true ) ) ) {
				if( function_exists( 'gzinflate' ) ) {
					if( ( $r = @gzinflate( $var2 ) ) ) {
						if( !$r = unserialize( $r ) ) {
							return false;
						}
					}
					else {
						if( !( $r = @unserialize( $var2 ) ) ) {
							return false;
						}
					}
				}
				else {
					if( !( $r = @unserialize( $var2 ) ) ) {
						return false;
					}
				}
			}
			else {
				if( !( $r = @unserialize( $var ) ) ) {
					return false;
				}
			}
		}
		return $r;
	}
}